#version 330

uniform	vec4 diffuse;
uniform float limb_darkening;

in Data {
	vec3 normal;
	vec3 l_dir;
	vec3 pos_cam;
} DataIn;

out vec4 colorOut;

void main() {

	// normalize both input vectors
	vec3 n = normalize(DataIn.normal);
	vec3 l = DataIn.l_dir;
	// compute view vector
	vec3 v = normalize(-DataIn.pos_cam);

	// aux variables to simplify equations

	float dot_NL = max(0.01f, dot(n,l));
	float dot_NV = max(0.01f, dot(n,v));

	float intensity = dot_NL * pow(dot_NL * dot_NV, limb_darkening - 1) ;

	colorOut = max(intensity *  diffuse, diffuse * 0.05); 

    
}
