#version 330

uniform	vec4 diffuse;
uniform vec4 specular;
uniform float shininess;

in Data {
	vec3 normal;
	vec3 l_dir;
	vec3 pos_cam;
} DataIn;

out vec4 colorOut;

void main() {

	// normalize both input vectors
	vec3 n = normalize(DataIn.normal);
	vec3 l = DataIn.l_dir;
	
	float intensity = max(dot(n,l), 0.0);

    float specInt = 0.0;
    if (intensity > 0.0) {

        // compute view vector
        vec3 v = normalize(DataIn.pos_cam);
        // half vector
        vec3 h = normalize(l+v);

        specInt = pow(max(dot(h,n),0.0), shininess);
    }


    if (specInt < 0)
        colorOut = vec4(1,0,0,0);
    else
        colorOut = vec4(0,1,0,0);
    colorOut = vec4( specInt);
	colorOut = max(intensity * diffuse + specInt * specular, diffuse * 0.25);
}
