#version 330


uniform	mat4 m_pvm;
uniform	mat4 m_view;
uniform	mat4 m_viewModel;
uniform	mat3 m_normal;
uniform	vec4 l_dir;	   // global space

in vec4 position;	// local space
in vec3 normal;		// local space
in vec2 texCoord0;

// the data to be sent to the fragment shader
out Data {
	vec3 normal;
	vec3 l_dir;
	vec3 pos_cam; // vertex position in camera space
    vec2 texCoord;
} DataOut;

void main () {
	
	DataOut.normal = normalize(m_normal * normal);
	DataOut.l_dir = normalize(vec3(m_view * -l_dir));
	DataOut.pos_cam = -vec3(m_viewModel * position);
    DataOut.texCoord = texCoord0 ;

	gl_Position = m_pvm * position;	
}
