#version 330


uniform	mat4 m_pvm;
uniform	mat4 m_view;
uniform	mat4 m_viewModel;
uniform	mat3 m_normal;
uniform	vec4 l_dir;	   // global space

in vec4 position;	// local space
in vec4 tangent;
in vec3 normal;		// local space

// the data to be sent to the fragment shader
out Data {
	vec3 normal;
    vec3 tangent;
    vec3 bitangent;
	vec3 l_dir;
	vec3 pos_cam;
} DataOut;

void main () {
	
	DataOut.normal = normalize(m_normal * normal);
	DataOut.l_dir = normalize(vec3(m_view * -l_dir));
	DataOut.pos_cam = vec3(m_viewModel * position);
    DataOut.tangent = vec3(m_viewModel * tangent);
    DataOut.bitangent = cross(DataOut.normal, DataOut.tangent);

	gl_Position = m_pvm * position;	
}
