#version 130

uniform sampler2D tex;

// note white can be RGB
uniform float lumBoost = 1.0; 

in vec2 texCoordV;

out vec4 outColor;

// The code in this file was originally written by Stephen Hill (@self_shadow), for HLSL

// sRGB => XYZ => D65_2_D60 => AP1 => RRT_SAT
const mat3x3 ACESInputMat =mat3x3(
    0.59719, 0.07600, 0.02840, 
    0.35458, 0.90834, 0.13383,
    0.04823, 0.01566, 0.83777
);

// ODT_SAT => XYZ => D60_2_D65 => sRGB
const mat3x3 ACESOutputMat = mat3x3(
     1.60475, -0.10208, -0.00327, 
     -0.53108, 1.10813, -0.07276, 
     -0.07367,-0.00605,  1.07602
);

vec3 RRTAndODTFit(vec3 v)
{
    vec3 a = v * (v + 0.0245786f) - 0.000090537f;
    vec3 b = v * (0.983729f * v + 0.4329510f) + 0.238081f;
    return a / b;
}

void main() {

	vec3 auxColor = texture(tex, texCoordV).xyz * lumBoost;

    auxColor = ACESInputMat * auxColor;
    auxColor = RRTAndODTFit(auxColor);
    auxColor = ACESOutputMat * auxColor;
    outColor = clamp(vec4(auxColor,1), 0, 1);

}