#version 130

uniform sampler2D tex;

// note white can be RGB
uniform float white = 1.0; 

in vec2 texCoordV;

out vec4 outColor;

void main() {

	outColor = texture(tex, texCoordV);
    float orig_lum = dot(vec3(outColor), vec3(0.2126f, 0.7152f, 0.0722f));
    float new_lum = orig_lum * (1 + orig_lum/(white*white)) / (1 + orig_lum);
    outColor = outColor * (new_lum/orig_lum);

}