#version 130

uniform sampler2D tex;

// note white can be RGB
uniform float exposure_bias = 2.0; 

in vec2 texCoordV;

out vec4 outColor;

vec4 uncharted2_tonemap_partial(vec4 x)
{
    float A = 0.15f;
    float B = 0.50f;
    float C = 0.10f;
    float D = 0.20f;
    float E = 0.02f;
    float F = 0.30f;
    return ((x*(A*x+C*B)+D*E)/(x*(A*x+B)+D*F))-E/F;
}

void main() {


	outColor = texture(tex, texCoordV);

    // tone mapping
    vec4 curr = uncharted2_tonemap_partial(outColor * exposure_bias);
    vec4 W = vec4(11.2f);
    vec4 white_scale = vec4(1.0f) / uncharted2_tonemap_partial(W);
    outColor = curr * white_scale;
}